/*****************************************************************************/
/* SubstanceP.h - A library for object list.                                 */
/*                                                                           */
/* SubstanceP.h Copyright (c) 2000 Sakai Hiroaki.                            */
/* All Rights Reserved.                                                      */
/*****************************************************************************/

#ifndef _SAKAILIB_SUBSTANCEP_H_INCLUDED_
#define _SAKAILIB_SUBSTANCEP_H_INCLUDED_

#include "Substance.h"

/* ֥Ȥ core ʬ */
typedef struct _SubstanceCore {
  char * class_name; /* ֥ȤΥ饹̾ */
  char * name;       /* ֥Ȥ̾ */
  int number;        /* ֥Ȥֹ(饹Ωʤ) */
  int serial;        /* ֥ȤΥꥢֹ(饹ǶѤʤ) */
  Substance parent;     /* ƤΥ֥ */
  SubstanceList children; /* ҤΥ֥ȤΥꥹ */
} _SubstanceCore;

/* ǡǼѹ¤ */
typedef struct _SubstanceListData {
  struct _SubstanceListData * prev; /* Υǡ */
  struct _SubstanceListData * next; /* Υǡ */
  Substance substance; /* ֥ */
  Substance (*destructor)(Substance); /* ˸ƤФǥȥ饯 */
} _SubstanceListData;

/* ꥹȹ¤δ */
typedef struct _SubstanceList {
  struct _SubstanceListData * start_edge; /*  */
  struct _SubstanceListData * end_edge;   /*  */
  struct _SubstanceListData * current;
  int length;
} _SubstanceList;

typedef struct _SubstanceListData * SubstanceListData;

#endif
